=== debian/changelog ===
libxsmm (1.17-4) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.7.0, no changes needed
  * Add patch to make the build reproducible.
    Thanks to Chris Lamb for the patch (Closes: #1013257)
  * Set R³:no.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 31 Jul 2024 17:47:36 +0900

libxsmm (1.17-3) unstable; urgency=medium

  * Team upload.
  * debian/control: Remove myself from the uploaders list.

  [ Debian Janitor ]
  * Use secure copyright file specification URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Boyuan Yang <byang@debian.org>  Sat, 09 Mar 2024 20:57:29 -0500

libxsmm (1.17-2) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.6.1.
  * Import changes from Ubuntu:

  [ Nick Rosbrook ]
  * debian/patches: Cherry-pick upstream patches to fix undefined reference to
    pthread_yield (LP: #1984111) (Closes: #1017469).

 -- Boyuan Yang <byang@debian.org>  Thu, 25 Aug 2022 10:20:37 -0400

libxsmm (1.17-1) unstable; urgency=medium

  * New upstream version 1.17.
    + Fix old CVEs:
      - CVE-2018-20541
      - CVE-2018-20542 (Closes: #917526)
      - CVE-2021-39535
      - CVE-2021-39536 (Closes: #996098)
  * Add myself as package uploader. (Closes: #962949)
  * debian/control: Use up-to-date homepage information.
  * Bump Standards-Version to 4.6.0.
  * debian/rules: Use vanilla build for now.
  * debian/docs: Also install upstream documentation.
  * debian/patches: Refresh patches:
    + Makefile_rebuild_fix.patch: Refreshed.
    - 0004-Force-python3.patch: Dropped, useless.
    - destdir.patch: Dropped for now.
    - remove_stdc++_link.patch: Dropped for now.
  * debian/patches: Add new patches:
    + 0002-Makefile-fix-pkgconfigdir.patch: Fix pkgconfigdir.

 -- Boyuan Yang <byang@debian.org>  Sat, 19 Mar 2022 20:01:55 -0400
