=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

export PREFIX=/usr
export TARGET=-""

%:
	dh $@

execute_after_dh_auto_clean:
	# Auto-generated files during dh_auto_clean
	rm -rf samples/deeplearning/tf_lstm_ops/.state
	rm -rf samples/deeplearning/tf_lstm_ops/obj/

execute_after_dh_auto_install:
	# Do not include docs in /usr/share/libxsmm
	rm -f debian/*/usr/share/libxsmm/*.md
	rm -f debian/*/usr/share/libxsmm/*.pdf
	# Do not include build.txt
	rm -f ./debian/*/usr/share/libxsmm/build.txt

execute_after_dh_installdocs:
	# Do not install broken symlinks
	rm -f debian/*/usr/share/doc/libxsmm-dev/documentation/CONTRIBUTING.md
	rm -f debian/*/usr/share/doc/libxsmm-dev/documentation/LICENSE.md
	rm -f debian/*/usr/share/doc/libxsmm-dev/documentation/gxm.md
