=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libxsmm-$1.tar.gz%" \
 https://github.com/hfp/libxsmm/releases \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
